#ifndef TULIP_HPP_
#define TULIP_HPP_

#include <Block/SpriteBlock/SpriteBlock.hpp>

class Tulip : public SpriteBlock
{
private:
    static std::vector<Sprite> makeSprites();

public:
    /**
     * @brief Construct the tulip block.
     * 
     * @param name The name of this block.
     */
    Tulip(std::string name);

    virtual bool canPlace(LocalWorld &world, IWorldActor &actor, glm::ivec3 pos, Side side, uint8_t &meta) override;
    virtual bool isIntersectedBy(World &world, glm::ivec3 pos, const BoundingBox<wfixed> &box) override;
    virtual bool canManuallyDig() override;
    virtual void onNeighborUpdated(LocalWorld &world, glm::ivec3 pos, Side side) override;
    virtual bool canSweepAway() override;
};

#endif